<template>
	<el-row class="marginTop20 saleList">
		<el-row class="flexVcenter">
			<div class="marginRight10 f14 c9696A0" style="display:inline-block;width:120px;">申请日期</div>
			<el-col :span="12">
				<el-date-picker
					v-model="selectDate"
					type="daterange"
					size="small"
					range-separator="至"
					start-placeholder="开始日期"
					end-placeholder="结束日期"
					value-format="yyyyMMdd"
				></el-date-picker>
			</el-col>
			<div class="marginRight10 f14 c9696A0" style="display:inline-block;width:120px;">放款状态</div>
			<el-col :span="8">
				<el-select v-model="tableConf.params.makeLoanStatus" clearable placeholder="请选择">
					<el-option v-for="item in loanStatuslist" :key="item.value" :label="item.label" :value="item.value"></el-option>
				</el-select>
			</el-col>
			<div class="marginRight10 f14 c9696A0" style="display:inline-block;width:120px;">还款状态</div>
			<el-col :span="8">
				<el-select v-model="tableConf.params.repayStatus" clearable placeholder="请选择">
					<el-option v-for="item in repayStatusList" :key="item.value" :label="item.label" :value="item.value"></el-option>
				</el-select>
			</el-col>
		</el-row>
		<ootecoTable class="marginTop30" ref="noticeTable" :conf="tableConf" :url="'biz/select/list'"></ootecoTable>
		<el-dialog title="还款登记" :visible.sync="dialogRepayVisible">
			<el-form :model="form">
				<el-row>
					<el-col :span="12" :offset="6">
						<el-form-item label="还款金额">
							<el-input
								v-model="form.amount"
								style="width:21.25rem;"
								autocomplete="off"
								placeholder="请输入还款金额"
							></el-input>
						</el-form-item>
					</el-col>
				</el-row>
				<el-row>
					<el-col :span="12" :offset="6">
						<el-form-item label="还款日期">
							<el-date-picker
								v-model="form.repayDate"
								value-format="yyyyMMdd"
								type="date"
								placeholder="选择日期"
							></el-date-picker>
						</el-form-item>
					</el-col>
				</el-row>
				<el-row>
					<el-col :span="12" :offset="6">
						<el-form-item label="电子回单">
							<ootecoUpload :conf="repayOrderUpload"></ootecoUpload>
						</el-form-item>
					</el-col>
				</el-row>
			</el-form>
			<div slot="footer" class="dialog-footer flexHcenter">
				<el-button @click="dialogRepayVisible = false">取 消</el-button>
				<el-button type="primary" @click="repayLogConfirm">确 定</el-button>
			</div>
		</el-dialog>
	</el-row>
</template>

<script>
import ootecoTable from '@com/ooteco_table'
import salesList from './data_conf/salesList.js'
import ootecoUpload from '@com/ooteco_upload'
import { Form } from 'element-ui'
export default {
	mixins: [$mixin],
	components: { ootecoTable, ootecoUpload },
	data() {
		return Object.assign({}, salesList, {
			selectDate: '',
			multipleSelection: [],
			dialogRepayVisible: false,
			form: {
				amount: '',
				repayDate: '',
				businessId: ''
			},
			repayOrderUpload: {
				url: '',
				type: 'button',
				class: 2
			}
		})
	},
	computed: {
		selectListen(){
			return this.tableConf.params.makeLoanStatus + this.tableConf.params.repayStatus;
		}
	},
	watch: {
		selectDate(val) {
			this.$set(this.tableConf.params, 'applyBeginDate', val[0])
			this.$set(this.tableConf.params, 'applyEndDate', val[1])
			if (
				this.tableConf.params.applyBeginDate &&
				this.tableConf.params.applyEndDate
			) {
				this.$refs.noticeTable.requestData()
			}
		},
		selectListen(){
			this.$refs.noticeTable.requestData()
		}
	},
	methods: {
		repayLogConfirm() {
			let [formData, condition] = [new FormData(), false]
			for (const key in this.form) {
				if (!this.form[key]) {
					condition = true
				}

				formData.append(key, this.form[key])
			}
			if (condition || !this.repayOrderUpload.file) {
				this.alert('请完善信息')
				return false
			}
			formData.append('repayFiles', this.repayOrderUpload.file)
			this.$http
				.post({
					url: 'biz/add/repay',
					params: formData
				})
				.then(
					({ data }) => {
						this.alert('操作成功')
					},
					msg => {
						this.alert(msg)
					}
				)
		},
		initListen() {
			this.listen('infoDetail', () => {
				let arr = this.tableConf.data.filter(item => {
					return item.radio === this.tableConf.radio
				})
				if (!arr.length) {
					this.alert('请先选择一笔业务')
					return false
				}
				this.go('saleOpration', { businessId: arr[0].id })
				this.$set(this.tableConf, 'radio', -1)
			})
		}
	},
	mounted() {
		this.initListen()
	}
}
</script>

<style lang="less">
.saleList {
	tr {
		td {
			div {
				text-align: center;
			}
		}
	}
}
</style>
